Thanks for submitting the crash error.
I finally found the solution to my problem!
My initial goal was to convert each existing face in a component to a new child component.
This is not without but the objective was for me to deepen my knowledge of various classes and methods in the API.
Thanks to this I discovered the class Face, Edge, Array, Transformation, UVHelper and ComponentInstance which is a good start. 
The first thing I wanted to do is convert each face of my component to a group directly in the parent component instance.
I then realized that life could not be so easy.
As faces have edges and vertices connected to other faces, it is impossible to group faces one by one without creating phantom faces as seen with Dan in this Topic.
The solution then is to redraw all the faces with the same texturing properties.
I first wanted to create an instance of edeges and use “find_faces” to create a new face.
It worked well but when I wanted to apply the UVs they were out of place.
I already explained it earlier in the topic, but when you create a new component instance, a new origin axis is automatically created, which therefore redefines the UVQ values ​​if the axis is not the same.
So if I copy the UVs before grouping to apply them to the new instance, the texuration will not be in the right place.
The solution is therefore to apply the UV before grouping and converting the face into a component instance.
For that I had to redraw all the faces outside the parent component, I then converted these faces into a group and then into a component instance to load them inside the parent component.
I know that it will be difficult for you to understand my explanations and that is why I post all my method below:
def faces_uv_front(f, uv_front)
posy = []
uv = []
uv_helper = f.get_UVHelper(true, false)
f.outer_loop.vertices.each do |vert|
qut = posy.count
if qut <= 3
posy << vert.position
uvq = uv_helper.get_front_UVQ(vert.position)
u = uvq.x / uvq.z
v = uvq.y / uvq.z
uv << Geom::Point3d.new(u,v)
end
end
map = posy.zip(uv)
uv_front << map.flatten!
end
def convert_faces_to_componant(f)
mod = Sketchup.active_model
ents = mod.active_entities
pts = []
f.outer_loop.vertices.each{|vert| pts << vert.position }
new_face = ents.add_face(pts)
uv_front = []
faces_uv_front(f, uv_front)
uv_front.flatten!
m = f.material
n = f.normal
normal = new_face.normal
if normal != n
new_face.reverse!
end
mat = new_face.material = m
new_face.position_material(mat, uv_front, true)
grp = ents.add_group(new_face)
inst = grp.to_component
tr = inst.transformation
pts = tr.origin
defn = inst.definition
defn.name = "Component#1"
inst.erase!
f.parent.entities.add_instance(defn, pts)
f.erase!
end
def face_all_componant(sel, faces)
sel.grep(Sketchup::ComponentInstance) do |s|
s.definition.entities.grep(Sketchup::Face) do |f|
faces << f
end
face_all_componant(s.definition.entities, faces)
end
end
faces = []
mod = Sketchup.active_model
sel = mod.selection
mod.start_operation('Convert faces to components', true)
face_all_componant(sel,faces)
for f in faces
convert_faces_to_componant(f)
end
mod.commit_operation
If you have things to do, you no longer need to waste your time replying to me on this topic. 